# Week 12 Tasks for practicals

# Task 1 : Tuples, sets and lists 

Tuples and lists are existing abstractions that can help us structure data and apply generalised programming concepts in our code. 

## 1.1 
Use a tuple or a set to represent a delivery van which contains the name of the driver, the registration of the van and the number of packages it has to deliver. Make at least 4 concrete instances and then capture these in a list.

## 1.2

Write a function that simulates the delivery of one packages by subtracting one from the number of packages it contains. Use a for loop to apply this to every element in your list (created in section 1.1)

> Tip: you may need to re-evaluate your choices in task 1.2 in order to implement this function.

## 1.3

Abstract the concept from the work above into a class, creating a `DeliveryVan` class.

## 1.4

Make a member function called `deliver_package` that implements the logic above. Make some example instances of your class, store them in a list simulate the delivery of a packages for every instance using a for loop.

# Task 2 (Assessment work)

## 2.1

For the problem that you have been working on for your assessment, begin to build some abstractions to represent the entities from last weeks ERD. You may use classes and other containers as is appropriate.

## 2.2

Document your work in your `portfolio.md` including code snippets as examples in the abstraction and patterns section (approximately 150 words).


# Task 3

Based on your work from task 1, implement an code that implements the following features:

- if the drivers name is Ellis, assign them 100 packages
- if drivers name is Nathan assign them 20 packages
- Other wise, assign them 50 packages

- if the registration of a van is DF07 EXE then it should deliver 2 packages for each delivery
- if the registration of a van is DP08 SLO then it should deliver 1 package every other delivery

- Attempt to wrap the above in a loop that calls the deliver package function until all packages are delivered. You may add new functions to help with this.
> 	You may run into errors such as allowing the count of packages to become negative. If you reach this point, that is acceptable and you may save this solution for futures weeks (where we look at error handling)


# Task 4 (Assessment work)

Begin to implement an algorithm for your problem, focusing on using the ideas you have abstracted in task 2. You should ensure you are working with your tutor on this problem to get support. 

> Tip: This will feel like a big step in your programming journey if you are new to programming. Focus on a small part of your decomposed problem and don't be afraid to continue refining all of the previous steps in order to address this task. By the time you are completing this section a substantial part of your report will be completed! Ensure you are spending time discussing your problem with your tutor in order to get the most out of the practical sessions.
