# Week 10

**This weeks quiz:** https://go.uwe.ac.uk/ctapQuiz

This week we will be starting to get into problem solving more directly and working actively on the assessment work. Our topics for the first lecture this week are Decomposition and Problem solving.

This weeks **second lecture** will look at requirements elicitation.
## This week you are working on...

### 👉 [THIS WEEKS TASK](https://gitlab.uwe.ac.uk/ctap/ctap-resources/-/blob/main/practicals/week10/tasks.md?ref_type=heads) 👈

#### 👋[Updated Assignment Scenarios](https://gitlab.uwe.ac.uk/ctap/ctap-resources/-/blob/main/assignment-scenarios.md?ref_type=heads)👋

- Applying decomposition to problems and representing this with tree diagrams
- Exploring and defining the requirements of problems and evaluating these requirements

## Have already completed ...

You should have completed the setup by now. If MUST IMMEDIATELY address this!
Follow the [setup guide and ensuring you have done everything on the checklist](https://gitlab.uwe.ac.uk/ctap/ctap-resources/-/blob/main/guides/setup.md?ref_type=heads). You should then work to catch up on any missed sessions. 
**Please make yourself known to your tutor if you are behind or we will not know to help you!**

## By the end of the week...

... you should have completed:

- Reading Chapter 3 of Karl Beechers book 'Computational thinking: a beginner's guide to problem-solving and programming'
- Tasks 1, 2, 3 and 4 provided in `ctap-resources/practicals/week10/tasks.md`

## Resources
- [Chapter 3 of Computational thinking: a beginner's guide to problem-solving and programming](https://blackboard.uwe.ac.uk/webapps/blackboard/content/listContentEditable.jsp?content_id=_9740235_1&course_id=_358486_1&mode=reset)
- [practicals/week10/tasks.md](https://gitlab.uwe.ac.uk/ctap/ctap-resources/-/blob/main/practicals/week10/tasks.md?ref_type=heads)
- [Slides](https://go.uwe.ac.uk/ctapSlides)
- [Markdown Guide](https://gitlab.uwe.ac.uk/ctap/ctap-resources/-/blob/main/guides/markdown.md?ref_type=heads)

### External resources

- [Learn Python .org's interactive python tutorials](https://www.learnpython.org/)
- W3 schools [tutorial and reference](https://www.w3schools.com/python/)
- Raspberry Pi Foundation [tutorials](https://projects.raspberrypi.org/en/pathways/python-intro?gclid=Cj0KCQjwpompBhDZARIsAFD_Fp8FpuLGfd6v863VziU4rGdV-ZHkcnu-bhjB0KuGS1fyYLBHiXpazGcaAnGuEALw_wcB)

## Videos

- [Python in 100 seconds](https://www.youtube.com/watch?v=x7X9w_GIm1s)
- Learn [python in 1 hour](https://www.youtube.com/watch?v=kqtD5dpn9C8)